#!/home/rus043/anaconda2/bin/python
from mpl_toolkits.basemap import Basemap, cm
import cmocean
import sys, os, os.path
import matplotlib.pyplot as plt
from netCDF4 import Dataset
import numpy as np
from scipy import interpolate
import MITgcmutils

p = [];
wrf_output = './wrfinput_d01'
wrf_output_results = Dataset(wrf_output,'r',format='NETCDF4');
wrf_output_uwnd = wrf_output_results.variables['U10'][:];
wrf_output_vwnd = wrf_output_results.variables['V10'][:];
wrf_output_uoce = wrf_output_results.variables['UOCE'][:];
wrf_output_voce = wrf_output_results.variables['UOCE'][:];
wrf_lon = wrf_output_results.variables['XLONG'][:];
wrf_lat = wrf_output_results.variables['XLAT'][:];

fun_interpolate_uwnd = interpolate.RectBivariateSpline(wrf_lat[0,:,0],wrf_lon[0,0,:],wrf_output_uwnd[0,:,:])
fun_interpolate_vwnd = interpolate.RectBivariateSpline(wrf_lat[0,:,0],wrf_lon[0,0,:],wrf_output_vwnd[0,:,:])
fun_interpolate_uoce = interpolate.RectBivariateSpline(wrf_lat[0,:,0],wrf_lon[0,0,:],wrf_output_uoce[0,:,:])
fun_interpolate_voce = interpolate.RectBivariateSpline(wrf_lat[0,:,0],wrf_lon[0,0,:],wrf_output_voce[0,:,:])

ww3_lon = np.arange(30.039125,49.9999,0.07825)
ww3_lat = np.arange(10.039125,29.9999,0.07825)
ww3_meshX, ww3_meshY = np.meshgrid(ww3_lon,ww3_lat)

ww3_uwnd = np.zeros((256,256))
ww3_vwnd = np.zeros((256,256))
ww3_uoce = np.zeros((256,256))
ww3_voce = np.zeros((256,256))

for i in range(256):
  for j in range(256):
    ww3_uwnd[j,i] = fun_interpolate_uwnd(ww3_meshY[j,i],ww3_meshX[j,i])
    ww3_vwnd[j,i] = fun_interpolate_vwnd(ww3_meshY[j,i],ww3_meshX[j,i])
    ww3_uoce[j,i] = fun_interpolate_uoce(ww3_meshY[j,i],ww3_meshX[j,i])
    ww3_voce[j,i] = fun_interpolate_voce(ww3_meshY[j,i],ww3_meshX[j,i])

f_wnd=open('./wind.txt', 'w')
f_oce=open('./current.txt', 'w')
f_wnd.write('20000101 000000\n')
f_oce.write('20000101 000000\n')
## PRINT UX
for j in range(256):
  for i in range(256):
      f_wnd.write(str(ww3_uwnd[255-j,i])+' ')
      f_oce.write(str(ww3_uoce[255-j,i])+' ')
  f_wnd.write('\n')
  f_oce.write('\n')

## PRINT UY
for j in range(256):
  for i in range(256):
      f_wnd.write(str(ww3_vwnd[255-j,i])+' ')
      f_oce.write(str(ww3_voce[255-j,i])+' ')
  f_wnd.write('\n')
  f_oce.write('\n')

f_wnd.write('20200101 000000\n')
f_oce.write('20200101 000000\n')
for j in range(256):
  for i in range(256):
      f_wnd.write(str(ww3_uwnd[255-j,i])+' ')
      f_oce.write(str(ww3_uoce[255-j,i])+' ')
  f_wnd.write('\n')
  f_oce.write('\n')

for j in range(256):
  for i in range(256):
      f_wnd.write(str(ww3_vwnd[255-j,i])+' ')
      f_oce.write(str(ww3_voce[255-j,i])+' ')
  f_wnd.write('\n')
  f_oce.write('\n')
